macroScript Zoom_selected_keys
category:"Brads"
tooltip: "Zoom Selected Keys"
(
	selKeyArray = #()
	framearray = #()
	initialtracks = #()
	
	fn getAnimProp obj =
	(
		if obj.numSubs > 0 then
		(
			for i = 1 to obj.numSubs do
			(
				getAnimProp obj[i]
			)
		)
		else
		(
			if (obj.controller != undefined) do
			(
				if (keyTest = obj.keys) != undefined and keyTest.count > 0 do
				(
					keytest = obj.keys
					for k in 1 to keyTest.count where keytest[k].selected do
					(
						append selKeyArray keytest[k]
						trackviews.currentTrackView.selecttrack obj off
					)
				)
			)
		)
	)
	
	(
		actionMan.executeAction 1 "2020" -- Track View: Move Keys
	--	set current frame and in/out points for later restoration
		initialframe = currenttime
		initialstart = animationrange.start
		initialend = animationrange.end
		tv = trackviews.currentTrackView
	--	get the trackview track selection
		for i = 1 to tv.getnumtracks() do
		(
			if (tv.getselected i) != undefined then
			append initialtracks (tv.getindex (tv.getselected i))
		)
	--	clear the trackview track selection and reset the zoom
		actionMan.executeAction 1 "722"  -- Clear Track Selection
		actionMan.executeAction 1 "2180" -- Track View: Zoom Horizontal Extents
	--	get the selected keys on your selected objects in an array
		for o in selection do
		(
			getAnimProp o
			for i in o.modifiers do
			(
				if (custattributes.count i) > 0 then
				(
					for j = 1 to (custattributes.count i) do
					getAnimProp (custattributes.get i j)
				)
			)
			if (custattributes.count o) > 0 then
			(
				for i = 1 to (custattributes.count $) do
				(
					(
					--	prints out their names
					getAnimProp (custattributes.get $ i)
					)
				)
			)
		)
	--	extract the time information from those keys and put into an array
		for kframes in selkeyarray do
		(
			append framearray kframes.time
		)
	--	Set the animation range to the min and max time of those keys
		if framearray.count > 0 then
		(
			tempstart = (amin framearray)-1
			tempend = (amax framearray)+1
			animationrange = interval tempstart tempend
		)
		else
		(
			select (getcurrentselection())
		)
	--	Zoom the trackview
		(
			actionMan.executeAction 1 "2180" -- Track View: Zoom Horizontal Extents
			actionMan.executeAction 1 "1040" -- Track View: Zoom Value Extents
		)
	--	restore the original animation range, slidertime and track track selection
		(
--			for i in initialtracks do (tv.selecttrackbyindex i off)
			animationrange = interval initialstart initialend
			slidertime = initialframe
		)
	)
)
